// M5Kiss : Bibliothèque contenant des fonctions de conversion KISS, AX25 et TNC2.
// Ecrit par Frank LOBA (www.f4hdb.fr).
// Date création : 29/11/2022.
// Dernière mise à jour : 06/12/2022.


/**** DEBUT DE FICHIER ****/
#ifndef M5KISS_H
#define M5KISS_H


/**** INCLUSION DES FICHIERS EN-TETE ****/
#include <Arduino.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>


/**** DEFINITION DES CONSTANTES ****/

// PARAMETRES TNC2
#define TNC2_SSID_CAR	'-'
#define TNC2_DST_CAR	'>'
#define TNC2_VIA_CAR	','
#define TNC2_MSG_CAR	':'
#define TNC2_RPT_CAR	'*'

#define TNC2_CR	'\r'	// Non utilisé.
#define TNC2_LF	'\n'	// Non utilisé.


// PARAMETRES AX25
#define AX25_FLAG	0x7E

#define AX25_NAME_SIZE	6
#define AX25_SPACE	' '
#define AX25_MAX_RPT	8

#define AX25_SSID_RSD_MASK	0b01100000
#define AX25_SSID_EXT_MASK 	0b00000001
#define AX25_SSID_RPT_MASK	0b10000000
#define AX25_SSID_VAL_MASK	0b00011110

#define AX25_CONTROL_FIELD_UI	0x03
#define AX25_PROTOCOL_ID	0xF0

// PARAMETRES KISS
#define KISS_FEND	0xC0
#define KISS_FESC	0xDB
#define KISS_TFEND	0xDC
#define KISS_TFESC	0xDD
#define KISS_DATA	0x00


/**** DECLARATION DES FONCTIONS GLOBALES ****/
String  TNC2toAX25(String TrameTNC2);
String  AX25toTNC2(String TrameAX25);

String  EncoderKISS(String TrameX);
String  DecoderKISS(String TrameKISS);


/**** FIN DE FICHIER ****/
#endif
